=== modified file 'DBUS-API'
--- DBUS-API	2012-01-15 20:27:28 +0000
+++ DBUS-API	2011-11-26 23:08:17 +0000
@@ -93,11 +93,10 @@
    | Interval (a)            | t    | Read/Write | interval            |
    | LastApprovalRequest (g) | s    | Read       | N/A                 |
    | LastCheckedOK (h)       | s    | Read/Write | N/A                 |
-   | LastCheckerStatus (i)   | n    | Read       | N/A                 |
-   | LastEnabled (j)         | s    | Read       | N/A                 |
+   | LastEnabled (i)         | s    | Read       | N/A                 |
    | Name                    | s    | Read       | (Section name)      |
    | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (k)              | ay   | Write      | secret (or secfile) |
+   | Secret (j)              | ay   | Write      | secret (or secfile) |
    | Timeout (a)             | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
@@ -125,13 +124,10 @@
       always use an empty string when setting this property, to allow
       for possible future expansion.
    
-   i) The exit status of the last checker, -1 if it did not exit
-      cleanly, -2 if a checker has not yet returned.
-   
-   j) The date and time this client was last enabled, as an RFC 3339
+   i) The date and time this client was last enabled, as an RFC 3339
       string, or an empty string if this has not happened.
    
-   k) A raw byte array, not hexadecimal digits.
+   j) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -156,10 +152,13 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
+*** NewRequest(s: IP address)
+    A client at IP adress has asked for its password.
+
 * Copyright
 
-    Copyright © 2010-2012 Teddy Hogeborn
-    Copyright © 2010-2012 Björn Påhlsson
+    Copyright © 2010-2011 Teddy Hogeborn
+    Copyright © 2010-2011 Björn Påhlsson
   
 ** License:
    

=== modified file 'Makefile'
--- Makefile	2012-01-15 21:07:44 +0000
+++ Makefile	2011-12-21 00:33:12 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.5.3
+version=1.4.1
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -319,8 +319,6 @@
 		> $(MANDIR)/man5/mandos.conf.5.gz
 	gzip --best --to-stdout mandos-clients.conf.5 \
 		> $(MANDIR)/man5/mandos-clients.conf.5.gz
-	gzip --best --to-stdout intro.8mandos \
-		> $(MANDIR)/man8/intro.8mandos.gz
 
 install-client-nokey: all doc
 	install --directory $(PREFIX)/lib/mandos $(CONFDIR)

=== modified file 'NEWS'
--- NEWS	2012-01-15 21:07:44 +0000
+++ NEWS	2011-10-15 16:48:03 +0000
@@ -1,42 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.5.3 (2012-01-15)
-* Server
-** Add D-Bus property se.recompile.Client.LastCheckerStatus and use it
-   in mandos-monitor.
-* Client
-** Fix bugs in the example "bridge" network hook.
-
-Version 1.5.2 (2012-01-08)
-* Server
-** Removed D-Bus signal se.recompile.Mandos.NewRequest() added in
-   1.5.0.  It was buggy and was of questionable utility.
-
-Version 1.5.1 (2012-01-01)
-* Server
-** Include intro(8mandos) manual page, missing since migration from
-   README file in version 1.4.0.
-
-Version 1.5.0 (2012-01-01)
-* Client
-** Network hooks.  The Mandos client can now run custom scripts to take
-   up a network interface before the client is run.  Three example
-   scripts are provided: "wireless", "openvpn", and "bridge".
-   To facilitate this, the client now prefers network interfaces which
-   are up (if any) over all other interfaces.
-* Server
-** Persistent state.  Client state is now saved between server
-   restarts.
-** clients.conf file can now contain "enabled" setting for clients.
-** Bug fix: Fix rare crash bug.
-** Bug fix: Send corrent D-Bus type in PropertyChanged for
-   "ApprovalDelay", "ApprovalDuration", "Timeout", and
-   "ExtendedTimeout".
-** mandos-ctl: Bare numbers as arguments are taken to be milliseconds.
-** Bug fix: mandos-ctl --secret option now works.
-** New D-Bus signal: se.recompile.Mandos.NewRequest(s).
-
 Version 1.4.1 (2011-10-15)
 * Server
 ** Make D-Bus properties settable again, and handle checkers

=== modified file 'README'
--- README	2012-01-01 20:45:53 +0000
+++ README	2011-10-05 16:00:56 +0000
@@ -1,8 +1,7 @@
 Please see: http://www.recompile.se/mandos/man/intro.8mandos
 
 This information previously in this file has been moved to the
-intro(8mandos) manual page.  Go to the above URL, or install the
-Mandos server and run this command:
+intro(8mandos) manual page.  Go to the above URL, or run this command:
 
 	man 8mandos intro
 

=== modified file 'TODO'
--- TODO	2012-01-15 20:27:28 +0000
+++ TODO	2011-12-23 18:59:19 +0000
@@ -1,10 +1,14 @@
 -*- org -*-
 
+* Use _attribute_((nonnull)) wherever possible.
+
 * [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
 
 * mandos-applet
 
 * mandos-client
+** TODO [#B] Flag fprintf_plus so compiler checks the format string.
+** TODO [#A] OpenVPN network hook
 ** TODO [#A] Wireless network hook
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use struct sockaddr_storage instead of a union
@@ -69,15 +73,6 @@
 ** TODO Allow %%(checker)s as a runtime expansion
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
-** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods.
-** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal
-   TODO Deprecate se.recompile.Mandos.Client.PropertyChanged - annotate!
-   TODO Can use "invalidates" annotation to also emit on changed secret.
-** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object
-   Deprecate methods GetAllClients(), GetAllClientsWithProperties()
-   and signals ClientAdded and ClientRemoved.
-** TODO Save state periodically to recover better from hard shutdowns
-** TODO CheckerCompleted method, deprecate CheckedOK
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -86,6 +81,7 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
+** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
@@ -96,7 +92,8 @@
 ** Urwid client data displayer
    Better view of client data in the listing
 *** Properties popup
-** Print a nice "We are sorry" message, save stack trace to log.
+** Nicer crashes. Stack traces Messes up shell.
+*** Print a nice "We are sorry" message, save stack trace to log.
 ** Show timeout countdown for approval
 
 * mandos-keygen

=== modified file 'common.ent'
--- common.ent	2012-01-15 21:07:44 +0000
+++ common.ent	2011-10-15 16:48:03 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.5.3">
+<!ENTITY version "1.4.1">

=== modified file 'debian/changelog'
--- debian/changelog	2012-02-21 21:20:12 +0000
+++ debian/changelog	2011-10-15 16:48:03 +0000
@@ -1,47 +1,3 @@
-mandos (1.5.3-1.1) unstable; urgency=low
-
-  * Non-maintainer upload.
-  * Fix "mandos FTBFS on buildds": add build-dependency on locales-all and
-    pass LC_ALL to dh_auto_build to make sure we have and use the en_US.UTF-8
-    locale for manpage creation.
-    (Closes: #656178)
-
- -- gregor herrmann <gregoa@debian.org>  Tue, 31 Jan 2012 17:56:05 +0100
-
-mandos (1.5.3-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 15 Jan 2012 22:05:54 +0100
-
-mandos (1.5.2-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 08 Jan 2012 11:17:20 +0100
-
-mandos (1.5.1-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 01 Jan 2012 21:53:31 +0100
-
-mandos (1.5.0-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (mandos-client/Depends): Added "initramfs-tools".
-  * debian/mandos-client.README.Debian: Corrected mail address and adjust
-                                        wording.
-  * debian/rules (binary-common): Exclude new nework-hooks.d directory
-                                  from dh_fixperms.
-  * debian/mandos-client.README.Debian: Document network hook facility.
-  * debian/mandos-client.docs (network-hooks.d): Added.
-  * debian/mandos.dirs (var/lib/mandos): Added.
-  * debian/mandos.postinst: Fix ownership of /var/lib/mandos.
-  * debian/control (mandos/Depends): Added "python-gnupginterface".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 01 Jan 2012 05:58:11 +0100
-
 mandos (1.4.1-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2012-02-21 21:20:12 +0000
+++ debian/control	2011-12-21 17:09:12 +0000
@@ -6,7 +6,7 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config, man, locales-all
+	pkg-config, man
 Standards-Version: 3.9.2
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files

=== modified file 'debian/copyright'
--- debian/copyright	2011-12-31 23:05:34 +0000
+++ debian/copyright	2011-10-10 20:29:58 +0000
@@ -4,8 +4,8 @@
 Source: <http://www.recompile.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2012 Teddy Hogeborn
-Copyright: Copyright © 2008-2012 Björn Påhlsson
+Copyright: Copyright © 2008-2011 Teddy Hogeborn
+Copyright: Copyright © 2008-2011 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2012-01-01 04:52:07 +0000
+++ debian/mandos-client.README.Debian	2011-11-28 22:15:04 +0000
@@ -33,12 +33,11 @@
 * Specifying a Client Network Interface
   
   At boot time the network interface to use will by default be
-  automatically detected.  If this should result in an incorrect
-  interface, edit the DEVICE setting in the
-  "/etc/initramfs-tools/initramfs.conf" file.  (The default setting is
-  empty, meaning it will autodetect the interface.)  *If* the DEVICE
-  setting is changed, it will be necessary to update the initrd image
-  by running the command
+  automatically detected.  If should result in an incorrect interface,
+  edit the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
+  file.  (The default setting is empty, meaning to autodetect the
+  interface.)  *If* the DEVICE setting is changed, it will be
+  necessary to update the initrd image by running the command
   
 	update-initramfs -k all -u
   

=== modified file 'debian/rules'
--- debian/rules	2012-02-21 21:20:12 +0000
+++ debian/rules	2011-11-27 14:44:28 +0000
@@ -38,12 +38,12 @@
 
 build-arch: build-arch-stamp
 build-arch-stamp: configure-stamp
-	LC_ALL=en_US.utf8 dh_auto_build -- all doc
+	dh_auto_build -- all doc
 	touch $@
 
 build-indep: build-indep-stamp
 build-indep-stamp: configure-stamp
-	LC_ALL=en_US.UTF-8 dh_auto_build -- doc
+	dh_auto_build -- doc
 	touch $@
 
 clean:
@@ -86,7 +86,7 @@
 		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
 		--exclude usr/lib/mandos/plugins.d \
-		--exclude usr/share/doc/mandos-client/network-hooks.d
+		--exclude /usr/share/doc/mandos-client/network-hooks.d
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol

=== modified file 'intro.xml'
--- intro.xml	2011-12-31 23:05:34 +0000
+++ intro.xml	2011-10-05 16:00:56 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -31,7 +31,6 @@
     </authorgroup>
     <copyright>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos'
--- mandos	2012-03-08 21:57:33 +0000
+++ mandos	2011-12-23 18:59:19 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2012 Teddy Hogeborn
-# Copyright © 2008-2012 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -65,7 +65,6 @@
 import types
 import binascii
 import tempfile
-import itertools
 
 import dbus
 import dbus.service
@@ -86,7 +85,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.5.3"
+version = "1.4.1"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -111,7 +110,7 @@
         return interface_index
 
 
-def initlogger(debug, level=logging.WARNING):
+def initlogger(level=logging.WARNING):
     """init logger and add loglevel"""
     
     syslogger.setFormatter(logging.Formatter
@@ -119,13 +118,12 @@
                             ' %(message)s'))
     logger.addHandler(syslogger)
     
-    if debug:
-        console = logging.StreamHandler()
-        console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
-                                               ' [%(process)d]:'
-                                               ' %(levelname)s:'
-                                               ' %(message)s'))
-        logger.addHandler(console)
+    console = logging.StreamHandler()
+    console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
+                                           ' [%(process)d]:'
+                                           ' %(levelname)s:'
+                                           ' %(message)s'))
+    logger.addHandler(console)
     logger.setLevel(level)
 
 
@@ -143,8 +141,7 @@
         self.gnupg.options.meta_interactive = False
         self.gnupg.options.homedir = self.tempdir
         self.gnupg.options.extra_args.extend(['--force-mdc',
-                                              '--quiet',
-                                              '--no-use-agent'])
+                                              '--quiet'])
     
     def __enter__(self):
         return self
@@ -176,7 +173,7 @@
     
     def encrypt(self, data, password):
         self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull, "w") as devnull:
+        with open(os.devnull) as devnull:
             try:
                 proc = self.gnupg.run(['--symmetric'],
                                       create_fhs=['stdin', 'stdout'],
@@ -193,12 +190,12 @@
     
     def decrypt(self, data, password):
         self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull, "w") as devnull:
+        with open(os.devnull) as devnull:
             try:
                 proc = self.gnupg.run(['--decrypt'],
                                       create_fhs=['stdin', 'stdout'],
                                       attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin']) as f:
+                with contextlib.closing(proc.handles['stdin'] ) as f:
                     f.write(data)
                 with contextlib.closing(proc.handles['stdout']) as f:
                     decrypted_plaintext = f.read()
@@ -416,14 +413,14 @@
     last_checked_ok: datetime.datetime(); (UTC) or None
     last_checker_status: integer between 0 and 255 reflecting exit
                          status of last checker. -1 reflects crashed
-                         checker, -2 means no checker completed yet.
+                         checker, or None.
     last_enabled: datetime.datetime(); (UTC) or None
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
     timeout:    datetime.timedelta(); How long from last_checked_ok
                                       until this client is disabled
-    extended_timeout:   extra long timeout when secret has been sent
+    extended_timeout:   extra long timeout when password has been sent
     runtime_expansions: Allowed attributes for runtime expansion.
     expires:    datetime.datetime(); time (UTC) when a client will be
                 disabled, or None
@@ -461,12 +458,9 @@
 
     @staticmethod
     def config_parser(config):
-        """Construct a new dict of client settings of this form:
+        """ Construct a new dict of client settings of this form:
         { client_name: {setting_name: value, ...}, ...}
-        with exceptions for any special settings as defined above.
-        NOTE: Must be a pure function. Must return the same result
-        value given the same arguments.
-        """
+        with exceptions for any special settings as defined above"""
         settings = {}
         for client_name in config.sections():
             section = dict(config.items(client_name))
@@ -476,8 +470,7 @@
             # Reformat values from string types to Python types
             client["approved_by_default"] = config.getboolean(
                 client_name, "approved_by_default")
-            client["enabled"] = config.getboolean(client_name,
-                                                  "enabled")
+            client["enabled"] = config.getboolean(client_name, "enabled")
             
             client["fingerprint"] = (section["fingerprint"].upper()
                                      .replace(" ", ""))
@@ -502,8 +495,15 @@
             client["checker_command"] = section["checker"]
             client["last_approval_request"] = None
             client["last_checked_ok"] = None
-            client["last_checker_status"] = -2
-        
+            client["last_checker_status"] = None
+            if client["enabled"]:
+                client["last_enabled"] = datetime.datetime.utcnow()
+                client["expires"] = (datetime.datetime.utcnow()
+                                     + client["timeout"])
+            else:
+                client["last_enabled"] = None
+                client["expires"] = None
+
         return settings
         
         
@@ -516,23 +516,12 @@
         for setting, value in settings.iteritems():
             setattr(self, setting, value)
         
-        if self.enabled:
-            if not hasattr(self, "last_enabled"):
-                self.last_enabled = datetime.datetime.utcnow()
-            if not hasattr(self, "expires"):
-                self.expires = (datetime.datetime.utcnow()
-                                + self.timeout)
-        else:
-            self.last_enabled = None
-            self.expires = None
-       
         logger.debug("Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
         logger.debug("  Fingerprint: %s", self.fingerprint)
-        self.created = settings.get("created",
-                                    datetime.datetime.utcnow())
+        self.created = settings.get("created", datetime.datetime.utcnow())
 
         # attributes specific for this server instance
         self.checker = None
@@ -627,16 +616,15 @@
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
-    def checked_ok(self):
-        """Assert that the client has been seen, alive and well."""
-        self.last_checked_ok = datetime.datetime.utcnow()
-        self.last_checker_status = 0
-        self.bump_timeout()
-    
-    def bump_timeout(self, timeout=None):
-        """Bump up the timeout for this client."""
+    def checked_ok(self, timeout=None):
+        """Bump up the timeout for this client.
+        
+        This should only be called when the client has been seen,
+        alive and well.
+        """
         if timeout is None:
             timeout = self.timeout
+        self.last_checked_ok = datetime.datetime.utcnow()
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
         if getattr(self, "enabled", False):
@@ -772,43 +760,6 @@
     return decorator
 
 
-def dbus_interface_annotations(dbus_interface):
-    """Decorator for marking functions returning interface annotations.
-    
-    Usage:
-    
-    @dbus_interface_annotations("org.example.Interface")
-    def _foo(self):  # Function name does not matter
-        return {"org.freedesktop.DBus.Deprecated": "true",
-                "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                    "false"}
-    """
-    def decorator(func):
-        func._dbus_is_interface = True
-        func._dbus_interface = dbus_interface
-        func._dbus_name = dbus_interface
-        return func
-    return decorator
-
-
-def dbus_annotations(annotations):
-    """Decorator to annotate D-Bus methods, signals or properties
-    Usage:
-    
-    @dbus_service_property("org.example.Interface", signature="b",
-                           access="r")
-    @dbus_annotations({{"org.freedesktop.DBus.Deprecated": "true",
-                        "org.freedesktop.DBus.Property."
-                        "EmitsChangedSignal": "false"})
-    def Property_dbus_property(self):
-        return dbus.Boolean(False)
-    """
-    def decorator(func):
-        func._dbus_annotations = annotations
-        return func
-    return decorator
-
-
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
@@ -837,25 +788,16 @@
     """
     
     @staticmethod
-    def _is_dbus_thing(thing):
-        """Returns a function testing if an attribute is a D-Bus thing
-        
-        If called like _is_dbus_thing("method") it returns a function
-        suitable for use as predicate to inspect.getmembers().
-        """
-        return lambda obj: getattr(obj, "_dbus_is_{0}".format(thing),
-                                   False)
+    def _is_dbus_property(obj):
+        return getattr(obj, "_dbus_is_property", False)
     
-    def _get_all_dbus_things(self, thing):
+    def _get_all_dbus_properties(self):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((getattr(athing.__get__(self), "_dbus_name",
-                         name),
-                 athing.__get__(self))
+        return ((prop.__get__(self)._dbus_name, prop.__get__(self))
                 for cls in self.__class__.__mro__
-                for name, athing in
-                inspect.getmembers(cls,
-                                   self._is_dbus_thing(thing)))
+                for name, prop in
+                inspect.getmembers(cls, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
@@ -863,8 +805,7 @@
         """
         for cls in  self.__class__.__mro__:
             for name, value in (inspect.getmembers
-                                (cls,
-                                 self._is_dbus_thing("property"))):
+                                (cls, self._is_dbus_property)):
                 if (value._dbus_name == property_name
                     and value._dbus_interface == interface_name):
                     return value.__get__(self)
@@ -899,8 +840,8 @@
             # signatures other than "ay".
             if prop._dbus_signature != "ay":
                 raise ValueError
-            value = dbus.ByteArray(b''.join(chr(byte)
-                                            for byte in value))
+            value = dbus.ByteArray(''.join(unichr(byte)
+                                           for byte in value))
         prop(value)
     
     @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="s",
@@ -912,7 +853,7 @@
         Note: Will not include properties with access="write".
         """
         properties = {}
-        for name, prop in self._get_all_dbus_things("property"):
+        for name, prop in self._get_all_dbus_properties():
             if (interface_name
                 and interface_name != prop._dbus_interface):
                 # Interface non-empty but did not match
@@ -933,9 +874,7 @@
                          path_keyword='object_path',
                          connection_keyword='connection')
     def Introspect(self, object_path, connection):
-        """Overloading of standard D-Bus method.
-        
-        Inserts property tags and interface annotation tags.
+        """Standard D-Bus method, overloaded to insert property tags.
         """
         xmlstring = dbus.service.Object.Introspect(self, object_path,
                                                    connection)
@@ -948,44 +887,12 @@
                 e.setAttribute("access", prop._dbus_access)
                 return e
             for if_tag in document.getElementsByTagName("interface"):
-                # Add property tags
                 for tag in (make_tag(document, name, prop)
                             for name, prop
-                            in self._get_all_dbus_things("property")
+                            in self._get_all_dbus_properties()
                             if prop._dbus_interface
                             == if_tag.getAttribute("name")):
                     if_tag.appendChild(tag)
-                # Add annotation tags
-                for typ in ("method", "signal", "property"):
-                    for tag in if_tag.getElementsByTagName(typ):
-                        annots = dict()
-                        for name, prop in (self.
-                                           _get_all_dbus_things(typ)):
-                            if (name == tag.getAttribute("name")
-                                and prop._dbus_interface
-                                == if_tag.getAttribute("name")):
-                                annots.update(getattr
-                                              (prop,
-                                               "_dbus_annotations",
-                                               {}))
-                        for name, value in annots.iteritems():
-                            ann_tag = document.createElement(
-                                "annotation")
-                            ann_tag.setAttribute("name", name)
-                            ann_tag.setAttribute("value", value)
-                            tag.appendChild(ann_tag)
-                # Add interface annotation tags
-                for annotation, value in dict(
-                    itertools.chain(
-                        *(annotations().iteritems()
-                          for name, annotations in
-                          self._get_all_dbus_things("interface")
-                          if name == if_tag.getAttribute("name")
-                          ))).iteritems():
-                    ann_tag = document.createElement("annotation")
-                    ann_tag.setAttribute("name", annotation)
-                    ann_tag.setAttribute("value", value)
-                    if_tag.appendChild(ann_tag)
                 # Add the names to the return values for the
                 # "org.freedesktop.DBus.Properties" methods
                 if (if_tag.getAttribute("name")
@@ -1026,7 +933,6 @@
     def __new__(mcs, name, bases, attr):
         # Go through all the base classes which could have D-Bus
         # methods, signals, or properties in them
-        old_interface_names = []
         for base in (b for b in bases
                      if issubclass(b, dbus.service.Object)):
             # Go though all attributes of the base class
@@ -1042,8 +948,6 @@
                 alt_interface = (attribute._dbus_interface
                                  .replace("se.recompile.Mandos",
                                           "se.bsnet.fukt.Mandos"))
-                if alt_interface != attribute._dbus_interface:
-                    old_interface_names.append(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
                     # Extract the original non-method function by
@@ -1064,12 +968,6 @@
                                 nonmethod_func.func_name,
                                 nonmethod_func.func_defaults,
                                 nonmethod_func.func_closure)))
-                    # Copy annotations, if any
-                    try:
-                        new_function._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
-                    except AttributeError:
-                        pass
                     # Define a creator of a function to call both the
                     # old and new functions, so both the old and new
                     # signals gets sent when the function is called
@@ -1103,12 +1001,6 @@
                                         attribute.func_name,
                                         attribute.func_defaults,
                                         attribute.func_closure)))
-                    # Copy annotations, if any
-                    try:
-                        attr[attrname]._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
-                    except AttributeError:
-                        pass
                 # Is this a D-Bus property?
                 elif getattr(attribute, "_dbus_is_property", False):
                     # Create a new, but exactly alike, function
@@ -1128,38 +1020,6 @@
                                         attribute.func_name,
                                         attribute.func_defaults,
                                         attribute.func_closure)))
-                    # Copy annotations, if any
-                    try:
-                        attr[attrname]._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
-                    except AttributeError:
-                        pass
-                # Is this a D-Bus interface?
-                elif getattr(attribute, "_dbus_is_interface", False):
-                    # Create a new, but exactly alike, function
-                    # object.  Decorate it to be a new D-Bus interface
-                    # with the alternate D-Bus interface name.  Add it
-                    # to the class.
-                    attr[attrname] = (dbus_interface_annotations
-                                      (alt_interface)
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
-        # Deprecate all old interfaces
-        basename="_AlternateDBusNamesMetaclass_interface_annotation{0}"
-        for old_interface_name in old_interface_names:
-            @dbus_interface_annotations(old_interface_name)
-            def func(self):
-                return { "org.freedesktop.DBus.Deprecated": "true" }
-            # Find an unused name
-            for aname in (basename.format(i) for i in
-                          itertools.count()):
-                if aname not in attr:
-                    attr[aname] = func
-                    break
         return type.__new__(mcs, name, bases, attr)
 
 
@@ -1179,6 +1039,9 @@
     def __init__(self, bus = None, *args, **kwargs):
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
+        self._approvals_pending = 0
+        
+        self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -1230,8 +1093,6 @@
                                        checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
-    last_checker_status = notifychangeproperty(dbus.Int16,
-                                               "LastCheckerStatus")
     last_approval_request = notifychangeproperty(
         datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
@@ -1315,13 +1176,6 @@
     ## D-Bus methods, signals & properties
     _interface = "se.recompile.Mandos.Client"
     
-    ## Interfaces
-    
-    @dbus_interface_annotations(_interface)
-    def _foo(self):
-        return { "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                     "false"}
-    
     ## Signals
     
     # CheckerCompleted - signal
@@ -1363,6 +1217,14 @@
         "D-Bus signal"
         return self.need_approval()
     
+    # NeRwequest - signal
+    @dbus.service.signal(_interface, signature="s")
+    def NewRequest(self, ip):
+        """D-Bus signal
+        Is sent after a client request a password.
+        """
+        pass
+    
     ## Methods
     
     # Approve - method
@@ -1478,12 +1340,6 @@
             return
         return datetime_to_dbus(self.last_checked_ok)
     
-    # LastCheckerStatus - property
-    @dbus_service_property(_interface, signature="n",
-                           access="read")
-    def LastCheckerStatus_dbus_property(self):
-        return dbus.Int16(self.last_checker_status)
-    
     # Expires - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Expires_dbus_property(self):
@@ -1501,25 +1357,26 @@
         if value is None:       # get
             return dbus.UInt64(self.timeout_milliseconds())
         self.timeout = datetime.timedelta(0, 0, 0, value)
+        if getattr(self, "disable_initiator_tag", None) is None:
+            return
         # Reschedule timeout
-        if self.enabled:
-            now = datetime.datetime.utcnow()
-            time_to_die = timedelta_to_milliseconds(
-                (self.last_checked_ok + self.timeout) - now)
-            if time_to_die <= 0:
-                # The timeout has passed
-                self.disable()
-            else:
-                self.expires = (now +
-                                datetime.timedelta(milliseconds =
-                                                   time_to_die))
-                if (getattr(self, "disable_initiator_tag", None)
-                    is None):
-                    return
-                gobject.source_remove(self.disable_initiator_tag)
-                self.disable_initiator_tag = (gobject.timeout_add
-                                              (time_to_die,
-                                               self.disable))
+        gobject.source_remove(self.disable_initiator_tag)
+        self.disable_initiator_tag = None
+        self.expires = None
+        time_to_die = timedelta_to_milliseconds((self
+                                                 .last_checked_ok
+                                                 + self.timeout)
+                                                - datetime.datetime
+                                                .utcnow())
+        if time_to_die <= 0:
+            # The timeout has passed
+            self.disable()
+        else:
+            self.expires = (datetime.datetime.utcnow()
+                            + datetime.timedelta(milliseconds =
+                                                 time_to_die))
+            self.disable_initiator_tag = (gobject.timeout_add
+                                          (time_to_die, self.disable))
     
     # ExtendedTimeout - property
     @dbus_service_property(_interface, signature="t",
@@ -1681,6 +1538,10 @@
                 except KeyError:
                     return
                 
+                if self.server.use_dbus:
+                    # Emit D-Bus signal
+                    client.NewRequest(str(self.client_address))
+                
                 if client.approval_delay:
                     delay = client.approval_delay
                     client.approvals_pending += 1
@@ -1750,7 +1611,7 @@
                 
                 logger.info("Sending secret to %s", client.name)
                 # bump the timeout using extended_timeout
-                client.bump_timeout(client.extended_timeout)
+                client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
                     client.GotSecret()
@@ -2099,11 +1960,11 @@
         sys.exit()
     if not noclose:
         # Close all standard open file descriptors
-        null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
+        null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
                           "%s not a character device"
-                          % os.devnull)
+                          % os.path.devnull)
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
         os.dup2(null, sys.stderr.fileno())
@@ -2217,13 +2078,13 @@
                                      stored_state_file)
     
     if debug:
-        initlogger(debug, logging.DEBUG)
+        initlogger(logging.DEBUG)
     else:
         if not debuglevel:
-            initlogger(debug)
+            initlogger()
         else:
             level = getattr(logging, debuglevel.upper())
-            initlogger(debug, level)
+            initlogger(level)
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
@@ -2232,8 +2093,7 @@
                                 % server_settings["servicename"]))
     
     # Parse config file with clients
-    client_config = configparser.SafeConfigParser(Client
-                                                  .client_defaults)
+    client_config = configparser.SafeConfigParser(Client.client_defaults)
     client_config.read(os.path.join(server_settings["configdir"],
                                     "clients.conf"))
     
@@ -2292,10 +2152,13 @@
          .gnutls_global_set_log_function(debug_gnutls))
         
         # Redirect stdin so all checkers get /dev/null
-        null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
+        null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         os.dup2(null, sys.stdin.fileno())
         if null > 2:
             os.close(null)
+    else:
+        # No console logging
+        logger.removeHandler(console)
     
     # Need to fork before connecting to D-Bus
     if not debug:
@@ -2306,7 +2169,7 @@
     
     global main_loop
     # From the Avahi example code
-    DBusGMainLoop(set_as_default=True)
+    DBusGMainLoop(set_as_default=True )
     main_loop = gobject.MainLoop()
     bus = dbus.SystemBus()
     # End of Avahi example code
@@ -2380,31 +2243,28 @@
             
             # Clients who has passed its expire date can still be
             # enabled if its last checker was successful.  Clients
-            # whose checker succeeded before we stored its state is
-            # assumed to have successfully run all checkers during
-            # downtime.
+            # whose checker failed before we stored its state is
+            # assumed to have failed all checkers during downtime.
             if client["enabled"]:
                 if datetime.datetime.utcnow() >= client["expires"]:
                     if not client["last_checked_ok"]:
                         logger.warning(
                             "disabling client {0} - Client never "
-                            "performed a successful checker"
-                            .format(client_name))
+                            "performed a successfull checker"
+                            .format(client["name"]))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
                             "disabling client {0} - Client "
                             "last checker failed with error code {1}"
-                            .format(client_name,
+                            .format(client["name"],
                                     client["last_checker_status"]))
                         client["enabled"] = False
                     else:
                         client["expires"] = (datetime.datetime
                                              .utcnow()
                                              + client["timeout"])
-                        logger.debug("Last checker succeeded,"
-                                     " keeping {0} enabled"
-                                     .format(client_name))
+                    
             try:
                 client["secret"] = (
                     pgp.decrypt(client["encrypted_secret"],
@@ -2419,14 +2279,12 @@
 
     
     # Add/remove clients based on new changes made to config
-    for client_name in (set(old_client_settings)
-                        - set(client_settings)):
+    for client_name in set(old_client_settings) - set(client_settings):
         del clients_data[client_name]
-    for client_name in (set(client_settings)
-                        - set(old_client_settings)):
+    for client_name in set(client_settings) - set(old_client_settings):
         clients_data[client_name] = client_settings[client_name]
 
-    # Create all client objects
+    # Create clients all clients
     for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
             name = client_name, settings = client)
@@ -2453,18 +2311,12 @@
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
     if use_dbus:
-        class MandosDBusService(DBusObjectWithProperties):
+        class MandosDBusService(dbus.service.Object):
             """A D-Bus proxy object"""
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
             _interface = "se.recompile.Mandos"
             
-            @dbus_interface_annotations(_interface)
-            def _foo(self):
-                return { "org.freedesktop.DBus.Property"
-                         ".EmitsChangedSignal":
-                             "false"}
-            
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
                 "D-Bus signal"
@@ -2563,14 +2415,9 @@
         except (IOError, OSError) as e:
             logger.warning("Could not save persistent state: {0}"
                            .format(e))
-            if not debug:
-                try:
-                    os.remove(tempname)
-                except NameError:
-                    pass
             if e.errno not in set((errno.ENOENT, errno.EACCES,
                                    errno.EEXIST)):
-                raise e
+                raise
         
         # Delete all clients, and settings from config
         while tcp_server.clients:

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2012-01-01 04:02:00 +0000
+++ mandos-clients.conf.xml	2011-11-26 23:08:17 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-11-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -36,7 +36,6 @@
       <year>2009</year>
       <year>2010</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -66,13 +65,8 @@
       ><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>, read by it at startup.
       The file needs to list all clients that should be able to use
-      the service.  The settings in this file can be overridden by
-      runtime changes to the server, which it saves across restarts.
-      (See the section called <quote>PERSISTENT STATE</quote> in
-      <citerefentry><refentrytitle>mandos</refentrytitle><manvolnum
-      >8</manvolnum></citerefentry>.)  However, any <emphasis
-      >changes</emphasis> to this file (including adding and removing
-      clients) will, at startup, override changes done during runtime.
+      the service.  All clients listed will be regarded as enabled,
+      even if a client was disabled in a previous run of the server.
     </para>
     <para>
       The format starts with a <literal>[<replaceable>section

=== modified file 'mandos-ctl'
--- mandos-ctl	2012-01-15 21:07:44 +0000
+++ mandos-ctl	2011-12-21 17:17:32 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2012 Teddy Hogeborn
-# Copyright © 2008-2012 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -60,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.5.3"
+version = "1.4.1"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -331,7 +331,8 @@
                            dbus_interface=dbus.PROPERTIES_IFACE)
             if options.secret is not None:
                 client.Set(client_interface, "Secret",
-                           dbus.ByteArray(options.secret.read()),
+                           dbus.ByteArray(open(options.secret,
+                                               "rb").read()),
                            dbus_interface=dbus.PROPERTIES_IFACE)
             if options.approved_by_default is not None:
                 client.Set(client_interface, "ApprovedByDefault",

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2011-12-31 23:05:34 +0000
+++ mandos-ctl.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,7 +33,6 @@
     <copyright>
       <year>2010</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-keygen'
--- mandos-keygen	2012-01-15 21:07:44 +0000
+++ mandos-keygen	2011-10-15 16:48:03 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2012 Teddy Hogeborn
-# Copyright © 2008-2012 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.5.3"
+VERSION="1.4.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2011-12-31 23:05:34 +0000
+++ mandos-keygen.xml	2011-11-12 18:14:55 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,7 +34,6 @@
       <year>2008</year>
       <year>2009</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-monitor'
--- mandos-monitor	2012-01-15 21:07:44 +0000
+++ mandos-monitor	2011-10-15 16:48:03 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2009-2012 Teddy Hogeborn
-# Copyright © 2009-2012 Björn Påhlsson
+# Copyright © 2009-2011 Teddy Hogeborn
+# Copyright © 2009-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -52,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.5.3"
+version = "1.4.1"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -131,6 +131,7 @@
         
         self._update_timer_callback_tag = None
         self._update_timer_callback_lock = 0
+        self.last_checker_failed = False
         
         # The widget shown normally
         self._text_widget = urwid.Text("")
@@ -144,8 +145,17 @@
         
         last_checked_ok = isoformat_to_datetime(self.properties
                                                 ["LastCheckedOK"])
+        if last_checked_ok is None:
+            self.last_checker_failed = True
+        else:
+            self.last_checker_failed = ((datetime.datetime.utcnow()
+                                         - last_checked_ok)
+                                        > datetime.timedelta
+                                        (milliseconds=
+                                         self.properties
+                                         ["Interval"]))
         
-        if self.properties ["LastCheckerStatus"] != 0:
+        if self.last_checker_failed:
             self.using_timer(True)
         
         if self.need_approval:
@@ -179,12 +189,7 @@
                                                          value)
         if property == "ApprovalPending":
             using_timer(bool(value))
-        if property == "LastCheckerStatus":
-            using_timer(value != 0)
-            #self.logger('Checker for client %s (command "%s")'
-            #            ' was successful'
-            #            % (self.properties["Name"], command))
-    
+        
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
         activated or deactivated.
@@ -205,9 +210,18 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
+            if self.last_checker_failed:
+                self.last_checker_failed = False
+                self.using_timer(False)
+            #self.logger('Checker for client %s (command "%s")'
+            #            ' was successful'
+            #            % (self.properties["Name"], command))
             self.update()
             return
         # Checker failed
+        if not self.last_checker_failed:
+            self.last_checker_failed = True
+            self.using_timer(True)
         if os.WIFEXITED(condition):
             self.logger('Checker for client %s (command "%s")'
                         ' failed with exit code %s'
@@ -228,13 +242,12 @@
         self.update()
     
     def checker_started(self, command):
-        """Server signals that a checker started. This could be useful
-           to log in the future. """
         #self.logger('Client %s started checker "%s"'
         #            % (self.properties["Name"], unicode(command)))
         pass
     
     def got_secret(self):
+        self.last_checker_failed = False
         self.logger('Client %s received its secret'
                     % self.properties["Name"])
     
@@ -301,7 +314,7 @@
             else:
                 message = "Denial in %s. (a)pprove?"
             message = message % unicode(timer).rsplit(".", 1)[0]
-        elif self.properties["LastCheckerStatus"] != 0:
+        elif self.last_checker_failed:
             # When checker has failed, print a timer until client expires
             expires = self.properties["Expires"]
             if expires == "":
@@ -484,6 +497,48 @@
         
         self.busname = domain + '.Mandos'
         self.main_loop = gobject.MainLoop()
+        self.bus = dbus.SystemBus()
+        mandos_dbus_objc = self.bus.get_object(
+            self.busname, "/", follow_name_owner_changes=True)
+        self.mandos_serv = dbus.Interface(mandos_dbus_objc,
+                                          dbus_interface
+                                          = server_interface)
+        try:
+            mandos_clients = (self.mandos_serv
+                              .GetAllClientsWithProperties())
+        except dbus.exceptions.DBusException:
+            mandos_clients = dbus.Dictionary()
+        
+        (self.mandos_serv
+         .connect_to_signal("ClientRemoved",
+                            self.find_and_remove_client,
+                            dbus_interface=server_interface,
+                            byte_arrays=True))
+        (self.mandos_serv
+         .connect_to_signal("ClientAdded",
+                            self.add_new_client,
+                            dbus_interface=server_interface,
+                            byte_arrays=True))
+        (self.mandos_serv
+         .connect_to_signal("ClientNotFound",
+                            self.client_not_found,
+                            dbus_interface=server_interface,
+                            byte_arrays=True))
+        for path, client in mandos_clients.iteritems():
+            client_proxy_object = self.bus.get_object(self.busname,
+                                                      path)
+            self.add_client(MandosClientWidget(server_proxy_object
+                                               =self.mandos_serv,
+                                               proxy_object
+                                               =client_proxy_object,
+                                               properties=client,
+                                               update_hook
+                                               =self.refresh,
+                                               delete_hook
+                                               =self.remove_client,
+                                               logger
+                                               =self.log_message),
+                            path=path)
     
     def client_not_found(self, fingerprint, address):
         self.log_message(("Client with address %s and fingerprint %s"
@@ -504,6 +559,7 @@
                                                      self.divider)))
         if self.log_visible:
             self.uilist.append(self.logbox)
+            pass
         self.topwidget = urwid.Pile(self.uilist)
     
     def log_message(self, message):
@@ -593,49 +649,6 @@
     
     def run(self):
         """Start the main loop and exit when it's done."""
-        self.bus = dbus.SystemBus()
-        mandos_dbus_objc = self.bus.get_object(
-            self.busname, "/", follow_name_owner_changes=True)
-        self.mandos_serv = dbus.Interface(mandos_dbus_objc,
-                                          dbus_interface
-                                          = server_interface)
-        try:
-            mandos_clients = (self.mandos_serv
-                              .GetAllClientsWithProperties())
-        except dbus.exceptions.DBusException:
-            mandos_clients = dbus.Dictionary()
-        
-        (self.mandos_serv
-         .connect_to_signal("ClientRemoved",
-                            self.find_and_remove_client,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        (self.mandos_serv
-         .connect_to_signal("ClientAdded",
-                            self.add_new_client,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        (self.mandos_serv
-         .connect_to_signal("ClientNotFound",
-                            self.client_not_found,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        for path, client in mandos_clients.iteritems():
-            client_proxy_object = self.bus.get_object(self.busname,
-                                                      path)
-            self.add_client(MandosClientWidget(server_proxy_object
-                                               =self.mandos_serv,
-                                               proxy_object
-                                               =client_proxy_object,
-                                               properties=client,
-                                               update_hook
-                                               =self.refresh,
-                                               delete_hook
-                                               =self.remove_client,
-                                               logger
-                                               =self.log_message),
-                            path=path)
-
         self.refresh()
         self._input_callback_tag = (gobject.io_add_watch
                                     (sys.stdin.fileno(),

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2011-12-31 23:05:34 +0000
+++ mandos-monitor.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,7 +33,6 @@
     <copyright>
       <year>2010</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2012-01-01 04:02:00 +0000
+++ mandos-options.xml	2011-11-26 22:22:20 +0000
@@ -87,8 +87,8 @@
   </para>
   
   <para id="restore">
-    This option controls whether the server will restore its state
-    from the last time it ran.  Default is to restore last state.
+    This option controls whether the server will restore any state from
+    last time it ran. Default is to try restore last state.
   </para>
   
   <para id="statedir">

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2011-12-31 23:05:34 +0000
+++ mandos.conf.xml	2011-11-26 22:22:20 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-11-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -35,7 +35,6 @@
       <year>2008</year>
       <year>2009</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos.lsm'
--- mandos.lsm	2012-01-15 21:07:44 +0000
+++ mandos.lsm	2011-10-15 16:48:03 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.5.3
-Entered-date:	2012-01-15
+Version:	1.4.1
+Entered-date:	2011-10-15
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      147K mandos_1.5.3.orig.tar.gz
+	      138K mandos_1.4.1.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		147K mandos_1.5.3.orig.tar.gz
+		138K mandos_1.4.1.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2012-01-15 21:01:13 +0000
+++ mandos.xml	2011-12-21 00:29:33 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2012-01-15">
+<!ENTITY TIMESTAMP "2011-11-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -35,7 +35,6 @@
       <year>2009</year>
       <year>2010</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -286,9 +285,6 @@
 	<term><option>--no-restore</option></term>
 	<listitem>
 	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	  <para>
-	    See also <xref linkend="persistent_state"/>.
-	  </para>
 	</listitem>
       </varlistentry>
       
@@ -381,7 +377,9 @@
       extended timeout, checker program, and interval between checks
       can be configured both globally and per client; see
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>.
+      <manvolnum>5</manvolnum></citerefentry>.  A client successfully
+      receiving its password will also be treated as a successful
+      checker run.
     </para>
   </refsect1>
   
@@ -415,18 +413,6 @@
     </para>
   </refsect1>
   
-  <refsect1 id="persistent_state">
-    <title>PERSISTENT STATE</title>
-    <para>
-      Client settings, initially read from
-      <filename>clients.conf</filename>, are persistent across
-      restarts, and run-time changes will override settings in
-      <filename>clients.conf</filename>.  However, if a setting is
-      <emphasis>changed</emphasis> (or a client added, or removed) in
-      <filename>clients.conf</filename>, this will take precedence.
-    </para>
-  </refsect1>
-  
   <refsect1 id="dbus_interface">
     <title>D-BUS INTERFACE</title>
     <para>

=== modified file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2012-01-15 16:10:09 +0000
+++ network-hooks.d/bridge	2011-11-28 23:40:46 +0000
@@ -6,9 +6,6 @@
 # configuration file(s) should be copied into the
 # /etc/mandos/network-hooks.d directory.
 # 
-# Copyright © 2011 Teddy Hogeborn
-# Copyright © 2011 Björn Påhlsson
-# 
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright
 # notice and this notice are preserved.  This file is offered as-is,
@@ -18,18 +15,13 @@
 
 CONFIG="$MANDOSNETHOOKDIR/bridge.conf"
 
-addrtoif(){
-    grep -liFe "$1" /sys/class/net/*/address \
-	| sed -e 's,.*/\([^/]*\)/[^/]*,\1,' -e "/^${BRIDGE}\$/d"
-}
-
-# Read config file, which must set "BRIDGE", "PORT_ADDRESSES", and
-# optionally "IPADDRS" and "ROUTES".
+# Read config file, which must set "BRIDGE", "PORTS", and optionally
+# "IPADDRS" and "ROUTES".
 if [ -e "$CONFIG" ]; then
     . "$CONFIG"
 fi
 
-if [ -z "$BRIDGE" -o -z "$PORT_ADDRESSES" ]; then
+if [ -z "$BRIDGE" -o -z "$PORTS" ]; then
     exit
 fi
 
@@ -37,8 +29,7 @@
     exit
 fi
 
-brctl="/sbin/brctl"
-for b in "$brctl" /usr/sbin/brctl; do
+for b in /sbin/brctl /usr/sbin/brctl; do
     if [ -e "$b" ]; then
 	brctl="$b"
 	break
@@ -48,13 +39,12 @@
 case "$1" in
     start)
 	"$brctl" addbr "$BRIDGE"
-	for address in $PORT_ADDRESSES; do
-	    interface=`addrtoif "$address"`
-	    "$brctl" addif "$BRIDGE" "$interface"
-	    ip link set dev "$interface" up
+	for port in $PORTS; do
+	    "$brctl" addif "$BRIDGE" "$port"
+	    ip link set up "$port"
 	done
-	ip link set dev "$BRIDGE" up
-	sleep "${DELAY%%.*}"
+	ip link set up "$BRIDGE"
+	sleep "$DELAY"
 	if [ -n "$IPADDRS" ]; then
             for ipaddr in $IPADDRS; do
 		ip addr add "$ipaddr" dev "$BRIDGE"
@@ -67,11 +57,10 @@
 	fi
 	;;
     stop)
-	ip link set dev "$BRIDGE" down
-	for address in $PORT_ADDRESSES; do
-	    interface=`addrtoif "$address"`
-	    ip link set dev "$interface" down
-	    "$brctl" delif "$BRIDGE" "$interface"
+	ip link set down "$BRIDGE"
+	for port in $PORTS; do
+	    ip link set down "$port"
+	    "$brctl" delif "$BRIDGE" "$port"
 	done
 	"$brctl" delbr "$BRIDGE"
 	;;

=== modified file 'network-hooks.d/bridge.conf'
--- network-hooks.d/bridge.conf	2011-12-31 13:25:58 +0000
+++ network-hooks.d/bridge.conf	2011-11-24 20:15:24 +0000
@@ -2,7 +2,7 @@
 
 #BRIDGE=br0
 
-#PORT_ADDRESSES="00:11:22:33:44:55 11:22:33:44:55:66"
+#PORTS="eth0 eth1"
 
 ## Optional
 

=== modified file 'network-hooks.d/openvpn'
--- network-hooks.d/openvpn	2012-01-01 17:38:33 +0000
+++ network-hooks.d/openvpn	2011-12-02 16:52:50 +0000
@@ -6,9 +6,6 @@
 # configuration file(s) should be copied into the
 # /etc/mandos/network-hooks.d directory.
 # 
-# Copyright © 2012 Teddy Hogeborn
-# Copyright © 2012 Björn Påhlsson
-# 
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright
 # notice and this notice are preserved.  This file is offered as-is,
@@ -19,9 +16,7 @@
 CONFIG="openvpn.conf"
 
 # Extract the "dev" setting from the config file
-VPNDEVICE=`sed -n -e 's/[[:space:]]#.*//' \
-    -e 's/^[[:space:]]*dev[[:space:]]\+//p' \
-    "$MANDOSNETHOOKDIR/$CONFIG"`
+VPNDEVICE="`sed -n -e 's/#.*//' -e 's/^[[:space:]]*dev[[:space:]]\+//p' \"$MANDOSNETHOOKDIR/$CONFIG\"`"
 
 PIDFILE=/run/openvpn-mandos.pid
 
@@ -39,9 +34,7 @@
 
 case "$1" in
     start)
-	"$openvpn" --cd "$MANDOSNETHOOKDIR" \
-	    --daemon 'openvpn(Mandos)' --writepid "$PIDFILE" \
-	    --config "$CONFIG"
+	"$openvpn" --cd "$MANDOSNETHOOKDIR" --daemon 'openvpn(Mandos)' --writepid "$PIDFILE" --config "$CONFIG"
 	sleep "$DELAY"
 	;;
     stop)

=== removed file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2012-01-01 17:38:33 +0000
+++ network-hooks.d/wireless	1970-01-01 00:00:00 +0000
@@ -1,160 +0,0 @@
-#!/bin/sh
-#
-# This is an example of a Mandos client network hook.  This hook
-# brings up a wireless interface as specified in a separate
-# configuration file.  To be used, this file and any needed
-# configuration file(s) should be copied into the
-# /etc/mandos/network-hooks.d directory.
-# 
-# Copyright © 2012 Teddy Hogeborn
-# Copyright © 2012 Björn Påhlsson
-# 
-# Copying and distribution of this file, with or without modification,
-# are permitted in any medium without royalty provided the copyright
-# notice and this notice are preserved.  This file is offered as-is,
-# without any warranty.
-
-set -e
-
-RUNDIR="/run"
-CTRL="$RUNDIR/wpa_supplicant-global"
-CTRLDIR="$RUNDIR/wpa_supplicant"
-PIDFILE="$RUNDIR/wpa_supplicant-mandos.pid"
-
-CONFIG="$MANDOSNETHOOKDIR/wireless.conf"
-
-addrtoif(){
-    grep -liFe "$1" /sys/class/net/*/address \
-	| sed -e 's,.*/\([^/]*\)/[^/]*,\1,'
-}
-
-# Read config file
-if [ -e "$CONFIG" ]; then
-    . "$CONFIG"
-else
-    exit
-fi
-
-ifkeys=`env | sed -n -e 's/^ADDRESS_\([^=]*\)=.*/\1/p' "$CONFIG" \
-    | sort -u`
-
-# Exit if DEVICE is set and is not any of the wireless interfaces
-if [ -n "$DEVICE" ]; then
-    while :; do
-	for KEY in $ifkeys; do
-	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
-	    INTERFACE=`addrtoif "$ADDRESS"`
-	    if [ "$INTERFACE" = "$DEVICE" ]; then
-		break 2
-	    fi
-	done
-	exit
-    done
-fi
-
-wpa_supplicant=/sbin/wpa_supplicant
-wpa_cli=/sbin/wpa_cli
-ip=/bin/ip
-
-# Used by the wpa_interface_* functions in the wireless.conf file
-wpa_cli_set(){
-    case "$1" in
-        ssid|psk) arg="\"$2\"" ;;
-        *) arg="$2" ;;
-    esac
-    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" set_network "$NETWORK" \
-	"$1" "$arg" 2>&1 | sed -e '/^OK$/d'
-}
-
-if [ $VERBOSITY -gt 0 ]; then
-    WPAS_OPTIONS="-d $WPAS_OPTIONS"
-fi
-if [ -n "$PIDFILE" ]; then
-    WPAS_OPTIONS="-P$PIDFILE $WPAS_OPTIONS"
-fi
-
-case "${MODE:-$1}" in
-    start)
-	mkdir -m u=rwx,go= -p "$CTRLDIR"
-	"$wpa_supplicant" -B -g "$CTRL" -p "$CTRLDIR" $WPAS_OPTIONS
-        for KEY in $ifkeys; do
-	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
-	    INTERFACE=`addrtoif "$ADDRESS"`
-	    DRIVER=`eval 'echo "$WPA_DRIVER_'"$KEY"\"`
-	    IFDELAY=`eval 'echo "$DELAY_'"$KEY"\"`
-	    "$wpa_cli" -g "$CTRL" interface_add "$INTERFACE" "" \
-		"${DRIVER:-wext}" "$CTRLDIR" > /dev/null \
-		| sed -e '/^OK$/d'
-	    NETWORK=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" \
-		add_network`
-	    eval wpa_interface_"$KEY"
-	    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" enable_network \
-		"$NETWORK" | sed -e '/^OK$/d'
-	    sleep "${IFDELAY:-$DELAY}" &
-	    sleep=$!
-	    while :; do
-		kill -0 $sleep 2>/dev/null || break
-		STATE=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" \
-		    status | sed -n -e 's/^wpa_state=//p'`
-		if [ "$STATE" = COMPLETED ]; then
-		    while :; do
-			kill -0 $sleep 2>/dev/null || break 2
-			UP=`cat /sys/class/net/"$INTERFACE"/operstate`
-			if [ "$UP" = up ]; then
-			    kill $sleep 2>/dev/null
-			    break 2
-			fi
-			sleep 1
-		    done
-		fi
-		sleep 1
-	    done &
-	    wait $sleep || :
-	    IPADDRS=`eval 'echo "$IPADDRS_'"$KEY"\"`
-	    if [ -n "$IPADDRS" ]; then
-		if [ "$IPADDRS" = dhcp ]; then
-		    ipconfig -c dhcp -d "$INTERFACE" || :
-		    #dhclient "$INTERFACE"
-		else
-		    for ipaddr in $IPADDRS; do
-			"$ip" addr add "$ipaddr" dev "$INTERFACE"
-		    done
-		fi
-	    fi
-	    ROUTES=`eval 'echo "$ROUTES_'"$KEY"\"`
-	    if [ -n "$ROUTES" ]; then
-		for route in $ROUTES; do
-		    "$ip" route add "$route" dev "$BRIDGE"
-		done
-	    fi
-        done
-	;;
-    stop)
-	"$wpa_cli" -g "$CTRL" terminate 2>&1 | sed -e '/^OK$/d'
-        for KEY in $ifkeys; do
-	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
-	    INTERFACE=`addrtoif "$ADDRESS"`
-	    "$ip" addr show scope global permanent dev "$INTERFACE" \
-		| while read type addr rest; do
-		case "$type" in
-		    inet|inet6)
-			"$ip" addr del "$addr" dev "$INTERFACE"
-			;;
-		esac
-	    done
-	    "$ip" link set dev "$INTERFACE" down
-	done
-	;;
-    files)
-	echo "$wpa_supplicant"
-	echo "$wpa_cli"
-	echo "$ip"
-	;;
-    modules)
-	if [ "$IPADDRS" = dhcp ]; then
-	    echo af_packet
-	fi
-	sed -n -e 's/#.*$//' -e 's/[ 	]*$//' \
-	    -e 's/^MODULE_[^=]\+=//p' "$CONFIG"
-	;;
-esac

=== removed file 'network-hooks.d/wireless.conf'
--- network-hooks.d/wireless.conf	2011-12-31 13:25:58 +0000
+++ network-hooks.d/wireless.conf	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-# Extra options for wpa_supplicant, if any
-#WPAS_OPTIONS=""
-
-# wlan0
-ADDRESS_0=00:11:22:33:44:55
-MODULE_0=ath9k
-#WPA_DRIVER_0=wext
-wpa_interface_0(){
-    # Use this format to set simple things:
-    wpa_cli_set ssid home
-    wpa_cli_set psk "secret passphrase"
-    # Use this format to do more complex things with wpa_cli:
-    #"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" bssid "$NETWORK" 00:11:22:33:44:55
-    #"$wpa_cli" -g "$CTRL" ping
-}
-#DELAY_0=10
-IPADDRS_0=dhcp
-#IPADDRS_0="192.0.2.3/24 2001:DB8::aede:48ff:fe71:f6f2/32"
-#ROUTES_0="192.0.2.0/24 2001:DB8::/32"
-
-#ADDRESS_1=11:22:33:44:55:66
-#MODULE_1=...
-#...

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-12-31 23:05:34 +0000
+++ plugin-runner.c	2011-11-24 21:12:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2012 Teddy Hogeborn
- * Copyright © 2008-2012 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -171,7 +171,6 @@
 }
 
 /* Helper function for add_argument and add_environment */
-__attribute__((nonnull))
 static bool add_to_char_array(const char *new, char ***array,
 			      int *len){
   /* Resize the pointed-to array to hold one more pointer */
@@ -200,7 +199,6 @@
 }
 
 /* Add to a plugin's argument vector */
-__attribute__((nonnull(2)))
 static bool add_argument(plugin *p, const char *arg){
   if(p == NULL){
     return false;
@@ -209,7 +207,6 @@
 }
 
 /* Add to a plugin's environment */
-__attribute__((nonnull(2)))
 static bool add_environment(plugin *p, const char *def, bool replace){
   if(p == NULL){
     return false;
@@ -289,7 +286,6 @@
 }
 
 /* Prints out a password to stdout */
-__attribute__((nonnull))
 static bool print_out_password(const char *buffer, size_t length){
   ssize_t ret;
   for(size_t written = 0; written < length; written += (size_t)ret){
@@ -303,7 +299,6 @@
 }
 
 /* Removes and free a plugin from the plugin list */
-__attribute__((nonnull))
 static void free_plugin(plugin *plugin_node){
   
   for(char **arg = plugin_node->argv; *arg != NULL; arg++){
@@ -421,12 +416,11 @@
     { .name = NULL }
   };
   
-  __attribute__((nonnull(3)))
   error_t parse_opt(int key, char *arg, struct argp_state *state){
     errno = 0;
     switch(key){
       char *tmp;
-      intmax_t tmp_id;
+      intmax_t tmpmax;
     case 'g': 			/* --global-options */
       {
 	char *plugin_option;
@@ -505,24 +499,24 @@
       /* This is already done by parse_opt_config_file() */
       break;
     case 130:			/* --userid */
-      tmp_id = strtoimax(arg, &tmp, 10);
+      tmpmax = strtoimax(arg, &tmp, 10);
       if(errno != 0 or tmp == arg or *tmp != '\0'
-	 or tmp_id != (uid_t)tmp_id){
+	 or tmpmax != (uid_t)tmpmax){
 	argp_error(state, "Bad user ID number: \"%s\", using %"
 		   PRIdMAX, arg, (intmax_t)uid);
 	break;
       }
-      uid = (uid_t)tmp_id;
+      uid = (uid_t)tmpmax;
       break;
     case 131:			/* --groupid */
-      tmp_id = strtoimax(arg, &tmp, 10);
+      tmpmax = strtoimax(arg, &tmp, 10);
       if(errno != 0 or tmp == arg or *tmp != '\0'
-	 or tmp_id != (gid_t)tmp_id){
+	 or tmpmax != (gid_t)tmpmax){
 	argp_error(state, "Bad group ID number: \"%s\", using %"
 		   PRIdMAX, arg, (intmax_t)gid);
 	break;
       }
-      gid = (gid_t)tmp_id;
+      gid = (gid_t)tmpmax;
       break;
     case 132:			/* --debug */
       debug = true;

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2011-12-31 23:05:34 +0000
+++ plugin-runner.xml	2011-10-05 16:56:06 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-05">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,7 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
-      <year>2012</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2011-12-31 23:05:34 +0000
+++ plugins.d/askpass-fifo.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2012 Teddy Hogeborn
- * Copyright © 2008-2012 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -46,7 +46,6 @@
 
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/askpass-fifo.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -34,7 +34,6 @@
       <year>2008</year>
       <year>2009</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-12-31 23:05:34 +0000
+++ plugins.d/mandos-client.c	2011-11-28 22:18:37 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2012 Teddy Hogeborn
- * Copyright © 2008-2012 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -170,14 +170,11 @@
 
 /* Function to use when printing errors */
 void perror_plus(const char *print_text){
-  int e = errno;
   fprintf(stderr, "Mandos plugin %s: ",
 	  program_invocation_short_name);
-  errno = e;
   perror(print_text);
 }
 
-__attribute__((format (gnu_printf, 2, 3)))
 int fprintf_plus(FILE *stream, const char *format, ...){
   va_list ap;
   va_start (ap, format);
@@ -205,13 +202,13 @@
 }
 
 /* Add server to set of servers to retry periodically */
-bool add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
-		int af){
+int add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
+	       int af){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
     perror_plus("malloc");
-    return false;
+    return -1;
   }
   *new_server = (server){ .ip = strdup(ip),
 			  .port = port,
@@ -219,7 +216,7 @@
 			  .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    return false;
+    return -1;
   }
   /* Special case of first server */
   if (mc.current_server == NULL){
@@ -236,9 +233,9 @@
   ret = clock_gettime(CLOCK_MONOTONIC, &mc.current_server->last_seen);
   if(ret == -1){
     perror_plus("clock_gettime");
-    return false;
+    return -1;
   }
-  return true;
+  return 0;
 }
 
 /* 
@@ -1033,11 +1030,8 @@
       if(ret == 0){
 	avahi_simple_poll_quit(mc.simple_poll);
       } else {
-	if(not add_server(ip, port, interface,
-			  avahi_proto_to_af(proto))){
-	  fprintf_plus(stderr, "Failed to add server \"%s\" to server"
-		       " list\n", name);
-	}
+	ret = add_server(ip, port, interface,
+			 avahi_proto_to_af(proto));
       }
     }
   }
@@ -1450,7 +1444,7 @@
 	  perror_plus("setenv");
 	  _exit(EX_OSERR);
 	}
-	ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
+	ret = setenv("VERBOSE", debug ? "1" : "0", 1);
 	if(ret == -1){
 	  perror_plus("setenv");
 	  _exit(EX_OSERR);
@@ -1473,17 +1467,8 @@
 	  _exit(EX_OSERR);
 	}
 	free(delaystring);
-	if(connect_to != NULL){
-	  ret = setenv("CONNECT", connect_to, 1);
-	  if(ret == -1){
-	    perror_plus("setenv");
-	    _exit(EX_OSERR);
-	  }
-	}
-	if(execl(fullname, direntry->d_name, mode, NULL) == -1){
-	  perror_plus("execl");
-	  _exit(EXIT_FAILURE);
-	}
+	ret = execl(fullname, direntry->d_name, mode, NULL);
+	perror_plus("execl");
       } else {
 	int status;
 	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
@@ -1608,7 +1593,7 @@
 	.group = 2 },
       { .name = "retry", .key = 132,
 	.arg = "SECONDS",
-	.doc = "Retry interval used when denied by the Mandos server",
+	.doc = "Retry interval used when denied by the mandos server",
 	.group = 2 },
       { .name = "network-hook-dir", .key = 133,
 	.arg = "DIR",
@@ -1686,6 +1671,8 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
+	fprintf_plus(state->out_stream,
+		     "Mandos plugin mandos-client: ");
 	fprintf_plus(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/mandos-client.xml	2011-11-27 14:44:28 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-11-27">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,7 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
-      <year>2012</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -583,23 +583,7 @@
 	  <listitem>
 	    <para>
 	      This will be the same as the <option>--delay</option>
-	      option passed to <command>&COMMANDNAME;</command>.  Is
-	      only set if <envar>MODE</envar> is
-	      <quote><literal>start</literal></quote> or
-	      <quote><literal>stop</literal></quote>.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><envar>CONNECT</envar></term>
-	  <listitem>
-	    <para>
-	      This will be the same as the <option>--connect</option>
-	      option passed to <command>&COMMANDNAME;</command>.  Is
-	      only set if <option>--connect</option> is passed and
-	      <envar>MODE</envar> is
-	      <quote><literal>start</literal></quote> or
-	      <quote><literal>stop</literal></quote>.
+	      option passed to <command>&COMMANDNAME;</command>.
 	    </para>
 	  </listitem>
 	</varlistentry>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-12-31 23:05:34 +0000
+++ plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2012 Teddy Hogeborn
- * Copyright © 2008-2012 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -72,18 +72,7 @@
 /* Needed for conflict resolution */
 const char plymouth_name[] = "plymouthd";
 
-__attribute__((format (gnu_printf, 2, 3), nonnull(1)))
-int fprintf_plus(FILE *stream, const char *format, ...){
-  va_list ap;
-  va_start (ap, format);
-  
-  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
-			     program_invocation_short_name));
-  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
-}
-
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;
@@ -96,7 +85,8 @@
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
-    fprintf(stderr, ": %s\n", strerror(errnum));
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
     error(status, errno, "vasprintf while printing error");
     return;
   }
@@ -119,18 +109,17 @@
      from the terminal.  Password-prompt will exit if it detects
      plymouth since plymouth performs the same functionality.
    */
-  __attribute__((nonnull))
   int is_plymouth(const struct dirent *proc_entry){
     int ret;
     int cl_fd;
     {
-      uintmax_t proc_id;
+      uintmax_t maxvalue;
       char *tmp;
       errno = 0;
-      proc_id = strtoumax(proc_entry->d_name, &tmp, 10);
+      maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
       
       if(errno != 0 or *tmp != '\0'
-	 or proc_id != (uintmax_t)((pid_t)proc_id)){
+	 or maxvalue != (uintmax_t)((pid_t)maxvalue)){
 	return 0;
       }
     }
@@ -139,7 +128,7 @@
     ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
 		   proc_entry->d_name);
     if(ret == -1){
-      error_plus(0, errno, "asprintf");
+      error(0, errno, "asprintf");
       return 0;
     }
     
@@ -148,7 +137,7 @@
     free(cmdline_filename);
     if(cl_fd == -1){
       if(errno != ENOENT){
-	error_plus(0, errno, "open");
+	error(0, errno, "open");
       }
       return 0;
     }
@@ -165,7 +154,7 @@
 	if(cmdline_len + blocksize + 1 > cmdline_allocated){
 	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
 	  if(tmp == NULL){
-	    error_plus(0, errno, "realloc");
+	    error(0, errno, "realloc");
 	    free(cmdline);
 	    close(cl_fd);
 	    return 0;
@@ -178,7 +167,7 @@
 	sret = read(cl_fd, cmdline + cmdline_len,
 		    cmdline_allocated - cmdline_len);
 	if(sret == -1){
-	  error_plus(0, errno, "read");
+	  error(0, errno, "read");
 	  free(cmdline);
 	  close(cl_fd);
 	  return 0;
@@ -187,7 +176,7 @@
       } while(sret != 0);
       ret = close(cl_fd);
       if(ret == -1){
-	error_plus(0, errno, "close");
+	error(0, errno, "close");
 	free(cmdline);
 	return 0;
       }
@@ -223,7 +212,7 @@
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
   if (ret == -1){
-    error_plus(1, errno, "scandir");
+    error(1, errno, "scandir");
   }
   free(direntries);
   return ret > 0;
@@ -260,7 +249,6 @@
       { .name = NULL }
     };
     
-    __attribute__((nonnull(3)))
     error_t parse_opt (int key, char *arg, struct argp_state *state){
       errno = 0;
       switch (key){
@@ -302,7 +290,7 @@
     case ENOMEM:
     default:
       errno = ret;
-      error_plus(0, errno, "argp_parse");
+      error(0, errno, "argp_parse");
       return EX_OSERR;
     case EINVAL:
       return EX_USAGE;
@@ -326,7 +314,7 @@
   
   if(tcgetattr(STDIN_FILENO, &t_old) != 0){
     int e = errno;
-    error_plus(0, errno, "tcgetattr");
+    error(0, errno, "tcgetattr");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -339,17 +327,17 @@
   sigemptyset(&new_action.sa_mask);
   ret = sigaddset(&new_action.sa_mask, SIGINT);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGHUP);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGTERM);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   /* Need to check if the handler is SIG_IGN before handling:
@@ -358,37 +346,37 @@
   */
   ret = sigaction(SIGINT, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
@@ -402,7 +390,7 @@
   t_new.c_lflag &= ~(tcflag_t)ECHO;
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
     int e = errno;
-    error_plus(0, errno, "tcsetattr-echo");
+    error(0, errno, "tcsetattr-echo");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -472,7 +460,7 @@
 	sret = write(STDOUT_FILENO, buffer + written, n - written);
 	if(sret < 0){
 	  int e = errno;
-	  error_plus(0, errno, "write");
+	  error(0, errno, "write");
 	  switch(e){
 	  case EBADF:
 	  case EFAULT:
@@ -494,7 +482,7 @@
       sret = close(STDOUT_FILENO);
       if(sret == -1){
 	int e = errno;
-	error_plus(0, errno, "close");
+	error(0, errno, "close");
 	switch(e){
 	case EBADF:
 	  status = EX_OSFILE;
@@ -510,11 +498,10 @@
     if(sret < 0){
       int e = errno;
       if(errno != EINTR and not feof(stdin)){
-	error_plus(0, errno, "getline");
+	error(0, errno, "getline");
 	switch(e){
 	case EBADF:
 	  status = EX_UNAVAILABLE;
-	  break;
 	case EIO:
 	case EINVAL:
 	default:
@@ -540,7 +527,7 @@
     fprintf(stderr, "Restoring terminal attributes\n");
   }
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
-    error_plus(0, errno, "tcsetattr+echo");
+    error(0, errno, "tcsetattr+echo");
   }
   
   if(quit_now){
@@ -548,7 +535,7 @@
     old_action.sa_handler = SIG_DFL;
     ret = sigaction(signal_received, &old_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
     }
     raise(signal_received);
   }

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/password-prompt.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -34,7 +34,6 @@
       <year>2008</year>
       <year>2009</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2011-12-31 23:05:34 +0000
+++ plugins.d/plymouth.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010-2012 Teddy Hogeborn
- * Copyright © 2010-2012 Björn Påhlsson
+ * Copyright © 2010-2011 Teddy Hogeborn
+ * Copyright © 2010-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -75,7 +75,6 @@
 }
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;
@@ -154,7 +153,6 @@
   return true;
 }
 
-__attribute__((nonnull (2, 3)))
 bool exec_and_wait(pid_t *pid_return, const char *path,
 		   const char **argv, bool interruptable,
 		   bool daemonize){
@@ -214,17 +212,16 @@
   return false;
 }
 
-__attribute__((nonnull))
 int is_plymouth(const struct dirent *proc_entry){
   int ret;
   {
-    uintmax_t proc_id;
+    uintmax_t maxvalue;
     char *tmp;
     errno = 0;
-    proc_id = strtoumax(proc_entry->d_name, &tmp, 10);
+    maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
 
     if(errno != 0 or *tmp != '\0'
-       or proc_id != (uintmax_t)((pid_t)proc_id)){
+       or maxvalue != (uintmax_t)((pid_t)maxvalue)){
       return 0;
     }
   }
@@ -265,36 +262,36 @@
 
 pid_t get_pid(void){
   int ret;
-  uintmax_t proc_id = 0;
+  uintmax_t maxvalue = 0;
   FILE *pidfile = fopen(plymouth_pid, "r");
   /* Try the new pid file location */
   if(pidfile != NULL){
-    ret = fscanf(pidfile, "%" SCNuMAX, &proc_id);
+    ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
     if(ret != 1){
-      proc_id = 0;
+      maxvalue = 0;
     }
     fclose(pidfile);
   }
   /* Try the old pid file location */
-  if(proc_id == 0){
+  if(maxvalue == 0){
     pidfile = fopen(plymouth_pid, "r");
     if(pidfile != NULL){
-      ret = fscanf(pidfile, "%" SCNuMAX, &proc_id);
+      ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
       if(ret != 1){
-	proc_id = 0;
+	maxvalue = 0;
       }
       fclose(pidfile);
     }
   }
   /* Look for a plymouth process */
-  if(proc_id == 0){
+  if(maxvalue == 0){
     struct dirent **direntries = NULL;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
     if (ret == -1){
       error_plus(0, errno, "scandir");
     }
     if (ret > 0){
-      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &proc_id);
+      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
       if (ret < 0){
 	error_plus(0, errno, "sscanf");
       }
@@ -304,8 +301,8 @@
     free(direntries);
   }
   pid_t pid;
-  pid = (pid_t)proc_id;
-  if((uintmax_t)pid == proc_id){
+  pid = (pid_t)maxvalue;
+  if((uintmax_t)pid == maxvalue){
     return pid;
   }
   

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/plymouth.xml	2011-11-12 18:14:55 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,7 +33,6 @@
     <copyright>
       <year>2010</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2011-12-31 23:05:34 +0000
+++ plugins.d/splashy.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2012 Teddy Hogeborn
- * Copyright © 2008-2012 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -61,7 +61,6 @@
 int signal_received;
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/splashy.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,7 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
-      <year>2012</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2011-12-31 23:05:34 +0000
+++ plugins.d/usplash.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2012 Teddy Hogeborn
- * Copyright © 2008-2012 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -58,7 +58,6 @@
 const char usplash_name[] = "/sbin/usplash";
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/usplash.xml	2011-11-12 18:14:55 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -34,7 +34,6 @@
       <year>2008</year>
       <year>2009</year>
       <year>2011</year>
-      <year>2012</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

